import numpy as np

Si = {}

## Silicon Density, [10]
Si['density'] = {}
Si['density']['T']   = 295 # K
Si['density']['rho'] = 2320 # kg/m^3

Si['thermcond'] = {}
Si['thermcond']['T'] = np.concatenate((
    np.linspace(1, 16, int((16-1)/1) + 1),
    np.array([18,]),
    np.linspace(20, 50, int((50-20) / 5) + 1),
    np.linspace(60, 100, int((100-60) / 10) + 1),
    np.array([150, 200, 250, 273.2, 300, 350]),
    np.linspace(400, 1600, int((1600-400) / 100) + 1),
    np.array([1685,])
)) # temp in K
Si['thermcond']['k'] =  np.array([ # thermal conductivity of Silicon entered in W/(cm K) for consistency with source, but converted to W/(m K) with *(100 cm/m)
    0.0448, # % 1, source says this is an extrapolated value
    0.317, #  % 2
    0.998, #  % 3
    2.26, #   % 4
    4.24, #   % 5
    6.86, #   % 6
    9.91, #   % 7
    13.4, #   % 8
    17.2, #   % 9
    21.1, #   % 10
    24.8, #   % 11
    28.7, #   % 12
    32.5, #   % 13
    36.0, #   % 14
    39.3, #   % 15
    42.2, #  % 16
    46.7, #   % 18
    49.4, #  % 20
    51.4, #  % 25
    48.1, #   % 30
    41.3, #   % 35
    35.3, #   % 40
    30.6, #   % 45
    26.8, #   % 50
    21.1, #   % 60
    16.8, #   % 70
    13.4, #  % 80
    10.8, #   % 90
    8.84, #   % 100      8.80 in [12]
    4.09, #   % 150      4.10 in [12]
    2.64, #   % 200      2.60 in [12]
    1.91, #  % 250      1.90 in [12]
    1.68, #   % 273.2
    1.48, # % 300      1.50 in [12]
    1.19, #  % 350
    0.989, # % 400      0.99 in [12]
    0.762 , # % 500      0.76 in [12]
    0.619 , # % 600      0.62 in [12]
    0.508, #  % 700
    0.422 , # % 800      0.42 in [12]
    0.359 , # % 900
    0.312 , # % 1000     0.31 in [12]
    0.279 , # % 1100
    0.257 , # % 1200     0.26 in [12]
    0.244 , # % 1300
    0.235 , # % 1400     0.24 in [12]
    0.227 , # % 1500
    0.221 , # % 1600
    0.220 , # % 1685
])*100

Si['specheat'] = {}
Si['specheat']['T'] = np.linspace(80, 310, int((310 - 80) / 10) + 1) #(80:10:310) # '; % temp in K
Si['specheat']['Cp'] = np.array([ #...% heat capacity entered in cal/(g K) for consisitency with source, but converted to J/(kg K) with *( 1000 (g/kg) )*( Conv.cal_to_joule (J/cal) )
    0.0441, #  % 80
    0.0527, #  % 90
    0.0612, #  % 100
    0.0694, #  % 110
    0.0773, #  % 120
    0.0847, #  % 130
    0.0922, #  % 140
    0.0993, #  % 150
    0.106, #   % 160
    0.113, #   % 170
    0.120, #  % 180
    0.126, #   % 190
    0.131, #   % 200
    0.136, #   % 210
    0.141, #   % 220
    0.144, #   % 230
    0.148, #   % 240
    0.151, #   % 250
    0.154, #   % 260
    0.157, #   % 270
    0.160, #   % 280
    0.163, #   % 290
    0.166, #   % 300
    0.168, #   % 310
    ])*1000*1/0.239

Si['thermaldiffusivity'] = {}
Si['thermaldiffusivity']['T'] = np.concatenate((
    np.linspace(10, 16, int(16-10) + 1),
    np.array([18, 20]),
    np.linspace(25, 50, int((50-25)/5) + 1),
    np.linspace(60, 100, int((100-60) / 10) + 1),
    np.array([150, 200, 250, 273.2, 300, 350]),
    np.linspace(400, 1600, int((1600-400) / 100) + 1),
    np.array([1685,])
)) #'; % temp in K
Si['thermaldiffusivity']['alpha'] =  np.array([ #...% m^2/s
    3.72, #    % 10     estimated
    3.27, #    % 11     estimated
    2.81, #    % 12     estimated
    2.37, #    % 13     estimated
    1.98, #    % 14     estimated
    1.64, #    % 15     estimated
    1.35, #    % 16     estimated
    0.918, #   % 18     estimated
    0.625, #   % 20     estimated
    0.265, #   % 25     estimated
    0.1275, #  % 30     estimated
    0.067, #   % 35     estimated
    0.0381, #  % 40     estimated
    0.0231, #  % 45     estimated
    0.015, #   % 50     estimated
    0.00742, # % 60     estimated
    0.00420, # % 70     estimated
    0.00262, # % 80     estimated
    0.00176, # % 90     estimated
    0.00127, # % 100    estimated
    4.10e-4, # % 150    estimated
    2.03e-4, # % 200    estimated
    1.26e-4, # % 250  
    1.06e-4, # % 273.2
    8.80e-5, # % 300  
    6.66e-5, # % 350  
    5.36e-5, # % 400  
    3.90e-5, # % 500 
    3.07e-5, # % 600 
    2.46e-5, # % 700 
    2.01e-5, # % 800 
    1.68e-5, # % 900 
    1.43e-5, # % 1000
    1.27e-5, # % 1100
    1.16e-5, # % 1200
    1.09e-5, # % 1300
    1.03e-5, # % 1400
    9.90e-6, # % 1500
    9.58e-6, # % 1600
    9.39e-6, # % 1685
    ])



#### CTE
Si['CTE'] = {}
Si['CTE']['T'] = np.concatenate((np.linspace(35,70,int((70-35)/5+1)),
                np.array([74,]),
                np.linspace(75,150,int((150-75)/5+1)),
                np.linspace(160,280,int((280-160)/10+1)),
                np.array([283,]),
                np.array([290,]),
                np.array([293.15,]),
                np.array([295,]),
                np.array([300,]),
                np.array([305,]),
               ))
Si['CTE']['alpha'] =  np.array([ # CTE entered in ppm/K for consistency with source, but converted to strain/K with *1e-6
    -0.10869, # 35
    -0.16820, # 40
    -0.23151, # 45
    -0.29376, # 50
    -0.35214, # 55
    -0.40066, # 60
    -0.43749, # 65
    -0.46232, # 70
    -0.4725 , # 74
    -0.47492, # 75
    -0.47490, # 80
    -0.46195, # 85
    -0.43614, # 90
    -0.39812, # 95
    -0.34961, # 100
    -0.28693, # 105
    -0.22107, # 110
    -0.14782, # 115
    -0.06733, # 120
     0.01877, # 125
     0.10873, # 130
     0.20119, # 135
     0.29523, # 140
     0.39083, # 145
     0.48623, # 150
     0.68358, # 160
     0.87850, # 170
     1.06000, # 180
     1.23550, # 190
     1.40470, # 200
     1.56170, # 210
     1.71050, # 220
     1.85090, # 230
     1.98270, # 240
     2.10620, # 250
     2.22190, # 260
     2.32980, # 270
     2.42930, # 280
     2.4610 , # 283
     2.52480, # 290
     2.5550 , # 293.15
     2.57170, # 295
     2.61230, # 300
     2.65000, # 305
    ])*1e-6;
